public class Locale { 
    public static final String NEW_BOOKMARK = " ";
    public static final String EDIT_BOOKMARK = " ";
    public static final String BOOKMARKS = "";
    public static final String NAME = "";
    public static final String EMPTY_NAME = "     ";
    public static final String BACK = "";
    public static final String QUIT = "";
    public static final String GOTO = "";
    public static final String ADD = "";
    public static final String RENAME = "";
    public static final String REMOVE= "";
    public static final String SEARCH = "";
    public static final String HELP = "";
    public static final String BEGIN = " ";
    public static final String END = " ";
    public static final String ERROR = "";
    public static final String MENU = " ";
    public static final String SETTINGS = "";
    public static final String SAVE = "";
    public static final String FONT = "";
    public static final String SLIDER = "";
    public static final String OVERLAP = "";
    public static final String HORIZONTAL = "";
    public static final String VERTICAL = "";    
    public static final String NOT_FOUND = "  ";
    public static final String INFO = "";
    public static final String CLOCK = "";
    public static final String BACKGROUND = "";
    public static final String WHITE = "";
    public static final String BLACK = "";
    
    public static final char HYPHEN = '-';

    static final String HELP_TEXT = 
        " :\n" + 
        ": \n" + 
        ": \n" + 
        ": \n" + 
        ": \n" + 
        "*   \n" + 
        "#   \n" + 
        "0  \n" + 
        "1-9  N  \n";

    public static char getChar(byte b) { 
        return (char)(b < 0 ? b == -88 ? 0x401 : b == -72 ? 0x451 : 
                      (0x400 | ((b & 0x7f) - 0x30)) : b);
    }
    
    public static int getRank(char ch) { 
        if (ch >= '' && ch <= '') {
            switch (Character.toLowerCase(ch)) {
            case '':
            case '':
            case '':
            case '':
            case '': 
                return 2;
            case '':
            case '':
            case '':
            case '':
            case '':
            case '':
            case '':
            case '':
            case '':
            case '':
                return 3;
            default:
                return 1;	
            }
        }
        return 4;
    }

    public static int split(StringBuffer buf, int pos) { 
        int i = pos-2;
        if (i > 0) { 
            char ch;
            int rank2 = 0, len = buf.length();
            for (int j = i; j < len && (rank2 = getRank(buf.charAt(j))) < 3; j++);
            if (rank2 != 3) { 
                while (--i >= 0 && (ch = buf.charAt(i)) != ' ' && (rank2 = getRank(ch)) != 3); 
                if (rank2 != 3) { 
                    return i+1;
                }
            }
            rank2 = getRank(buf.charAt(i));
            while (i > 2) { 
                if ((ch = buf.charAt(i-1)) == ' ') { 
                    return i;
                }
                int rank1 = getRank(ch);
                if (rank1 == 3) { 
                    char c1 = buf.charAt(i);
                    char c2 = buf.charAt(i+1);
                    if (rank2 <= 2 && 
                        (c1 == c2 // rule 5
                         || c1 == '' || c1 == '' // rule 4
                         || (c1 == '' && getRank(c2) <= 2) // rule 2
                         || (rank2 == 2 && c2 != '' && c2 != '' && getRank(c2) == 1))) // rule 3
                    {
                        if (i < pos-2) { 
                            return i+1;
                        }
                    } else if (rank2 < 4 && getRank(c2) < 4 && getRank(buf.charAt(i-2)) < 4) {
                        return i;
                    }
                }
                rank2 = rank1;
                i -= 1;
            }
        }
        return 0;
    }   
}
 		
